#include <chipcon/hal.h>
#include <chipcon/cc1010eb.h>
#include <stdio.h>
#include <string.h>

word modulo;

byte foobar(byte foo, byte bar) {
    return foo+bar;
}

void printHex(byte* hexData, word length) {
    int i;

    for (i=0; i<length; i++) {
        if (i%16==0)
            printf("%04x: ", i);
        else if (i%16==15)
            printf("%02bx\n", hexData[i]);
        else
            printf("%02bx ", hexData[i]);
    }
    printf("\n\n");
}

byte xdata desKey[]={
     DES_NORMAL_2_COMPACT_KEY(0xCD,0x64,0x74,0x03,0xBC,0x90,0xC4,0xC4), 0,
     DES_NORMAL_2_COMPACT_KEY(0xDA,0xCA,0x26,0x83,0x30,0x98,0x8A,0x7D), 0,
     DES_NORMAL_2_COMPACT_KEY(0x37,0x1E,0xC6,0x0F,0x26,0xC3,0xB2,0x9A)
};

byte xdata desBuffer[320] _at_ 0x0018;
byte xdata originalData[320];

int main() {
	word x;
    ulong actualPeriod;

	WDT_ENABLE(FALSE);	  

    RLED_OE(TRUE); YLED_OE(TRUE); GLED_OE(TRUE); BLED_OE(TRUE);

    x=halRFReadRSSI();

    UART0_SETUP(57600, CC1010EB_CLKFREQ, UART_NO_PARITY|UART_RX_TX|UART_POLLED);
    for (x=0; x<200; x++) {
        halRandomNumberGen(desBuffer, 320);
        printHex(desBuffer, 320);
    }

    memcpy(originalData, desBuffer, 320);
    x=(word)halDES(DES_SINGLE_DES|DES_ENCRYPT|DES_OFB_MODE, desBuffer, desKey, 320);
    if (!memcmp(originalData, desBuffer, 320)) {
        RLED=LED_ON;
        while (1);
    }
    x=(word)halDES(DES_SINGLE_DES|DES_DECRYPT|DES_OFB_MODE, desBuffer, desKey, 320);
    if (memcmp(originalData, desBuffer, 320)) {
        RLED=LED_ON;
        while (1);
    }

    halConfigADC(ADC_MODE_MULTI_CONTINUOUS|ADC_REFERENCE_VDD, CC1010EB_CLKFREQ, 0);
    ADC_SELECT_INPUT(ADC_INPUT_AD0);
    ADC_POWER(TRUE);
    ADC_RUN(TRUE);

    actualPeriod=halConfigTimer23(TIMER2|TIMER23_INT_TIMER, 10, CC1010EB_CLKFREQ);
    TIMER2_RUN(TRUE);

	while (1);
}


void timer2_isr() interrupt INUM_TIMER2 {
    static byte cnt=255, ledOn=0;

    INT_SETFLAG(INUM_TIMER2, INT_CLR);
    if (!cnt) {
        cnt=255;
        RLED=YLED=GLED=BLED=LED_OFF;
        ledOn=ADC_GET_SAMPLE_8BIT();
    }
    if (cnt-- <= ledOn)
        RLED=YLED=GLED=BLED=LED_ON;      
}


/*    ulong actualPeriod;
    char xdata str[200];

	WDT_ENABLE(FALSE);	  
    UART0_SETUP(57600, CC1010EB_CLKFREQ, UART_NO_PARITY|UART_RX_TX|UART_POLLED);
    
    do {
        gets(str, 200);
        printf("Hello World! You said: \"%s\"\n", str);
    } while(strcmp(str, "exit"));
    printf("So I'll go ahead and exit then. Byebye!\n");

    halCopy2Flash((byte code*)0x6000, (byte xdata*)0x200, 10, (byte xdata*)0x700, CC1010EB_CLKFREQ);
    x=foobar(x, 3);
    halWait(250, CC1010EB_CLKFREQ);

    actualPeriod=halConfigTimer01(TIMER0|TIMER01_INT_TIMER, 50000, CC1010EB_CLKFREQ, &modulo);
    if (actualPeriod)
        TIMER0_RUN(TRUE);

	YLED_OE(TRUE);
	RLED_OE(TRUE);
	YLED=LED_ON;
	RLED=LED_ON;

    for (x=0; x<1000; x++) {
        halWait(25, CC1010EB_CLKFREQ);
        YLED=!YLED;
    }
    TIMER0_RUN(FALSE);
    actualPeriod=halConfigTimer01(TIMER0|TIMER01_INT_TIMER, 50, CC1010EB_CLKFREQ, &modulo);
    if (actualPeriod)
        TIMER0_RUN(TRUE);
    for (x=0; x<100; x++) {
        halWait(250, CC1010EB_CLKFREQ);
        YLED=!YLED;
    }
*/


/*
	int i;
	byte *p, *q, *r; 
	bool b;


	q=(byte xdata*)0x300;
	for (i=0; i<128; i++)
		q[i]=0x55;
	q=(byte xdata*)0x380;
	for (i=0; i<128; i++)
		q[i]=0xAA;

	p=(byte code*)0x3000;

	q=(byte xdata*)0x400;
	for (i=0; i<300; i++)
		q[i]=i%256;

	r=(byte xdata*)0x370;

	GLED_OE(TRUE);
	GLED=LED_ON;

	b=halCopy2Flash(p+17, q, 300, r, CC1010EB_CLKFREQ);

	b=halCopy2Flash(p+111, r-100, 100, r, CC1010EB_CLKFREQ);
*/


